/* <!-- copyright */
/*
 * aria2 - a simple utility for downloading files faster
 *
 * Copyright (C) 2006 Tatsuhiro Tsujikawa
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/* copyright --> */
#include "LogFactory.h"
#include "SimpleLogger.h"
#include "NullLogger.h"

string LogFactory::filename;
Logger* LogFactory::logger = NULL;

Logger* LogFactory::getInstance() {
  if(logger == NULL) {
    if(filename.empty()) {
      logger = new NullLogger();
    } else {
      SimpleLogger* slogger = new SimpleLogger();
      slogger->openFile(filename);
      logger = slogger;
    }
  }
  return logger;
}

void LogFactory::release() {
  delete logger;
  logger = NULL;
}
