/* <!-- copyright */
/*
 * aria2 - a simple utility for downloading files faster
 *
 * Copyright (C) 2006 Tatsuhiro Tsujikawa
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/* copyright --> */
#include "MultiDiskAdaptor.h"

MultiDiskAdaptor::MultiDiskAdaptor(MultiDiskWriter* diskWriter):DiskAdaptor(diskWriter) {}

MultiDiskAdaptor::~MultiDiskAdaptor() {}

void MultiDiskAdaptor::setDiskWriterFileEntries() {
  ((MultiDiskWriter*)diskWriter)->setFileEntries(fileEntries);
}

string MultiDiskAdaptor::getFilePath() const {
  return storeDir;
}

void MultiDiskAdaptor::openFile() {
  topDir->createDir(storeDir, true);
  setDiskWriterFileEntries();
  DiskAdaptor::openFile();
}

void MultiDiskAdaptor::initAndOpenFile() {
  topDir->createDir(storeDir, true);
  setDiskWriterFileEntries();
  DiskAdaptor::initAndOpenFile();
}

void MultiDiskAdaptor::openExistingFile() {
  setDiskWriterFileEntries();
  DiskAdaptor::openExistingFile();
}

void MultiDiskAdaptor::onDownloadComplete() {
  closeFile();
  openFile();
}
